mergeObjects(Multiscroll.Tool.Pan.prototype, {
	createThumbnailInAdvance : function(evt) { with (this) {
		client = {
			frame : evt.originalTarget.ownerDocument.defaultView,
			document : evt.originalTarget.ownerDocument,
			body : (evt.originalTarget.ownerDocument.getElementsByTagName('body')[0])
						 ? evt.originalTarget.ownerDocument.getElementsByTagName('body')[0]
						 : evt.originalTarget.ownerDocument.getElementsByTagName('*')[0],
			window : evt.originalTarget.ownerDocument.contentWindow
		}
	
		if (client.body.nodeName == "window") return;
		if (client.document.location == null) return;
	
		var docBox = client.document.getBoxObjectFor(client.document.documentElement);
	
		var pageXOffset = client.frame.pageXOffset;
		var pageYOffset = client.frame.pageYOffset;
	
		var documentWidth = docBox.width;
		var documentHeight = docBox.height;
	
		var windowWidth = Math.min(client.frame.innerWidth, documentWidth); // why are scrollbars included
		var windowHeight = Math.min(client.frame.innerHeight, documentHeight); // in window.innerWidth?
	
		calculateGrid(clientX, clientY, windowWidth, windowHeight, documentWidth, documentHeight, pageXOffset, pageYOffset);
	
		docMarkerWidth = documentWidth * scaleFactor;
		docMarkerHeight = documentHeight * scaleFactor;
	
		if (Math.abs(Math.log(oldScaleFactor/scaleFactor)) > 0.1
				 || docOldLocation != client.document.location.href ) {
			var el = client.document.createElementNS("http://www.w3.org/1999/xhtml", "div");
			el.style.overflow = "hidden";
			this.cloneElementToThumbnail(client.body, el, scaleFactor);
			
			markerNode.thumbnail = el;
			oldScaleFactor = this.scaleFactor;
			docOldLocation = client.document.location.href;
		}
	} },
	cloneElementToThumbnail : function(source, target, scale) { with (this) {
		for (var i = 0; i < source.childNodes.length; i++) {
			target.appendChild(source.childNodes[i].cloneNode(true));
			scaleNodeRecursive(source.childNodes[i], target.childNodes[i], scale);
		}
		cs = client.frame.getComputedStyle(source, '');
		scaleProperty(target, cs, 'fontSize', 'font-size', scale);
		scaleProperty(target, cs, 'letterSpacing', 'letter-spacing', scale);
		scaleProperty(target, cs, 'lineHeight', 'line-height', scale);
		scaleProperty(target, cs, 'wordSpacing', 'word-spacing', scale);
		copyProperty(target, cs, 'backgroundColor', 'background-color');
		copyProperty(target, cs, 'backgroundImage', 'background-image');
		copyProperty(target, cs, 'backgroundRepeat', 'background-repeat');
	} },
	scaleNodeRecursive : function(original, node, scale) { with (this) {
		if (node.nodeName == "SCRIPT" || node.nodeName == "HR") {
			node.parentNode.replaceChild(client.document.createElementNS("http://www.w3.org/1999/xhtml", "script"), node);
		} else if (node.nodeType == 1) {
			scaleNode(original, node, scale);
			for (var i = 0; i < node.childNodes.length; i++) {
				if (node.childNodes[i].nodeType == 1)
			scaleNodeRecursive(original.childNodes[i], node.childNodes[i], scale);
			}
		}
	} },
	arrScalableStyles : [
		'backgroundPosition', 'background-position',
		'borderSpacing', 'border-spacing',
		'borderTopWidth', 'border-top-width',
		'borderRightWidth', 'border-right-width',
		'borderBottomWidth', 'border-bottom-width',
		'borderLeftWidth', 'border-left-width',
		'bottom', 'bottom',
		'fontSize', 'font-size',
		'height', 'height',
		'left', 'left',
		'letterSpacing', 'letter-spacing',
		'lineHeight', 'line-height',
		'marginTop', 'margin-top',
		'marginRight', 'margin-right',
		'marginBottom', 'margin-bottom',
		'marginLeft', 'margin-left',
		'markerOffset', 'marker-offset',
		'maxHeight', 'max-height',
		'maxWidth', 'max-width',
		'minHeight', 'min-height',
		'minWidth', 'min-width',
		'outlineWidth', 'outline-width',
		'paddingTop', 'padding-top',
		'paddingRight', 'padding-right',
		'paddingBottom', 'padding-bottom',
		'paddingLeft', 'padding-left',
		'right', 'right',
		'size', 'size',
		'textIndent', 'text-indent',
		'textShadow', 'text-shadow',
		'top', 'top',
		'verticalAlign', 'vertical-align',
		'width', 'width',
		'wordSpacing', 'word-spacing'
	],
	scaleNode : function(original, node, scale) { with (this) {
		cs = client.frame.getComputedStyle(original, '');	// we use original because nodes do not acquire
		if (node.nodeName == "TABLE") {		// position properties till they are flowed in
			if (!isNaN(node.cellPadding)) node.cellPadding *= scale;
			if (!isNaN(node.cellSpacing)) node.cellSpacing *= scale;
			if (!isNaN(node.border)) node.border *= scale;
			node.style.padding = '0px';	// Believe it or not, when these are set as CSS rules on a table they fail to 
			node.style.margin = '0px';	// show up in computedStyle - we can't discover their values, all we can do is kill.
		}
		for ( var i = 0; i < this.arrScalableStyles.length; i += 2 )
			scaleProperty(node, cs, this.arrScalableStyles[i], this.arrScalableStyles[i+1], scale);
	} },
	scaleProperty : function(node, cs, propertyCased, property_dashed, scale) { with (this) {
		property = cs.getPropertyValue(property_dashed);
		if ( property == '0px' || property == '' || property.slice(-1) == '%' ) return;
		value = (property == 'thin') ? 1 : (property == 'medium') ? 3 : (property == 'thick') ? 5 : Number(property.slice(0, -2));
		if ( value == 0 || isNaN(value) ) return;
		eval( "node.style." + propertyCased + "='" + value * scale + "px';" );
	} },
	copyProperty : function(node, cs, propertyCased, property_dashed) { with (this) {
		eval( "node.style." + propertyCased + "='" + cs.getPropertyValue(property_dashed) + "';" );
	} }
});
